#include <tonc.h>
#include "include/sprite.h"
#include "include/view.h"

extern OBJ_ATTR sprite_list[];
extern unsigned int sprite_count;
extern VIEWPORT view;

//****************************************************************************************
//* LINK SPRITES                                                                         *
//****************************************************************************************

static void scr_sprLinkStandU(u32 palette_index,int x,int y){
  OBJ_ATTR *spr= &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_SQUARE,
               ATTR1_SIZE_16,
               ATTR2_PALBANK(palette_index) | 0);
  obj_set_pos(&spr[sprite_count],x - 8,y - 20);
  obj_set_attr(&spr[sprite_count+1],
               ATTR0_WIDE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(palette_index) | 4);
  obj_set_pos(&spr[sprite_count+1],x - 8,y - 4);
  obj_set_attr(&spr[sprite_count+2],
               ATTR0_SQUARE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(palette_index) | 6);
  obj_set_pos(&spr[sprite_count+2],x - 16,y - 12);
  obj_set_attr(&spr[sprite_count+3],
               ATTR0_SQUARE,
               ATTR1_SIZE_8 | ATTR1_HFLIP,
               ATTR2_PALBANK(palette_index) | 6);
  obj_set_pos(&spr[sprite_count+3],x + 8,y - 12);
  sprite_count += 4;
}

static void scr_sprLinkStandD(u32 palette_index,int x,int y){
  OBJ_ATTR *spr = &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_SQUARE,
               ATTR1_SIZE_16,
               ATTR2_PALBANK(palette_index) | 7);
  obj_set_pos(&spr[sprite_count],x - 8,y - 20);
  obj_set_attr(&spr[sprite_count+1],
               ATTR0_WIDE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(palette_index) | 11);
  obj_set_pos(&spr[sprite_count+1],x - 8,y - 4);
  obj_set_attr(&spr[sprite_count+2],
               ATTR0_SQUARE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(palette_index) | 13);
  obj_set_pos(&spr[sprite_count+2],x - 16,y - 19);
  obj_set_attr(&spr[sprite_count+3],
               ATTR0_SQUARE,
               ATTR1_SIZE_8 | ATTR1_HFLIP,
               ATTR2_PALBANK(palette_index) | 13);
  obj_set_pos(&spr[sprite_count+3],x + 8,y - 19);
  sprite_count += 4;
}

static void scr_sprLinkStandL(u32 palette_index,int x,int y){
  OBJ_ATTR *spr= &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_SQUARE,
               ATTR1_SIZE_16,
               ATTR2_PALBANK(palette_index) | 14);
  obj_set_pos(&spr[sprite_count],x - 6,y - 21);
  obj_set_attr(&spr[sprite_count+1],
               ATTR0_WIDE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(palette_index) | 18);
  obj_set_pos(&spr[sprite_count+1],x - 6,y - 5);
  obj_set_attr(&spr[sprite_count+2],
               ATTR0_SQUARE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(palette_index) | 20);
  obj_set_pos(&spr[sprite_count+2],x - 14,y - 21);
  sprite_count += 3;
}

static void scr_sprLinkStandR(u32 palette_index,int x,int y){
  OBJ_ATTR *spr= &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_SQUARE,
               ATTR1_SIZE_16 | ATTR1_HFLIP,
               ATTR2_PALBANK(palette_index) | 14);
  obj_set_pos(&spr[sprite_count],x - 10,y - 21);
  obj_set_attr(&spr[sprite_count+1],
               ATTR0_WIDE,
               ATTR1_SIZE_8 | ATTR1_HFLIP,
               ATTR2_PALBANK(palette_index) | 18);
  obj_set_pos(&spr[sprite_count+1],x - 10,y - 5);
  obj_set_attr(&spr[sprite_count+2],
               ATTR0_SQUARE,
               ATTR1_SIZE_8 | ATTR1_HFLIP,
               ATTR2_PALBANK(palette_index) | 20);
  obj_set_pos(&spr[sprite_count+2],x + 6,y - 21);
  sprite_count += 3;
}

static void scr_sprLinkShadow(u32 palette_index,int x,int y){
  OBJ_ATTR *spr = &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_WIDE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(palette_index) | 21);
  obj_set_pos(&spr[sprite_count],x - 8,y - 2);
  sprite_count += 1;
}

//****************************************************************************************
//****************************************************************************************

static void (*spriteFunctions[5])(u32,int,int) = {
  &scr_sprLinkStandU,
  &scr_sprLinkStandD,
  &scr_sprLinkStandL,
  &scr_sprLinkStandR,
  &scr_sprLinkShadow
};

void draw_sprite(u32 sprite_index,u32 palette_index,int x,int y){
  (*spriteFunctions[sprite_index])(palette_index,(x >> 8) - view.x,(y >> 8) - view.y);
}